

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;

/**
 * CAN实例：通过CAN，收发数据
 * 前提：需要CAN工具
 */
public class CanDemo {

	private static StreamConnection streamConnection;
	private static InputStream inputStream;
	private static OutputStream outputStream;

	public static void main(String[] args) {

		System.out.println("Start Can Demo...");

		String host = "can:can0";

		try {

			// 建立连接
			streamConnection = (StreamConnection) Connector.open(host);
			
			inputStream = streamConnection.openInputStream();
			outputStream = streamConnection.openOutputStream();
			
			// 启动子线程，每1s发送数据
			new Thread(new Runnable() {

				public void run() {

					while (true) {
						try {

							Thread.sleep(1000);
							
							byte[] message = new byte[16];
							message[0] =0x01;
							message[4] =0x01;
							message[8] =0x05;
							outputStream.write(message);

						} catch (InterruptedException e) {
							e.printStackTrace();
						} catch (IOException e) {
							e.printStackTrace();
						}
					}
				}
			}).start();
			
			int len = 0;
			byte[] buffer = new byte[256];
			// 读数据
			while ((len = inputStream.read(buffer)) != -1) {
				
				String can_id = "";
				int can_dlc = 0;
				String data = "";
				
				for(int i = 0; i < len; i++) {
					if(i < 4) {
						String str = Integer.toHexString(buffer[i]);
						can_id = str + can_id;
					}
					
					if(i == 4) {
						can_dlc = buffer[i];
					}
					
					if(i > 7) {
						String str = Integer.toHexString(buffer[i]);
						data += str;
					}
				}
				System.out.println("can_id: " + can_id + ", can_dlc: " + can_dlc + ", data: " + data);
			}
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}

}
